//---------------------------------------------------------------
// Secwenta.mq4 
// 
//---------------------------------------------------------------
#property copyright ""
#property link      ""
//---------------------------------------------------------------                                    
extern double StopLoss   =100;     // SL 
extern double TakeProfit =35;      //  
extern double Lots       =0.01;     // 
extern double Prots      =10.00;    //    
bool Work=true;                    
string Secwenta;                       //  . 
int i1;
int num=0;
int num1=0;
string textVar;
double ExtMapBuffer1;
string symbol; int timeframe;
//+------------------------------------------------------------------+
int init()
  {
//---- 
   symbol = Symbol();
   timeframe =0;
//---- 
   return(0);
  }

//--------------------------------------------------------------- 2 --
int start()
  {
   int
   Total,                           //     
   Tip=-1,                          //  .  (B=0,S=1)
   Ticket;                          //  
   double
   Lot,                             // .   .
   Lts,                             // .   .
   Min_Lot,                         //   
   Step,                            //    
   Free,                            //   
   One_Lot,                         //   
   Price,                           //   
   SL,                              // SL   
   TP;                              // TP  
   bool
   Ans  =false,                     //    
   Cls_B=false,                     //     Buy
   Cls_S=false,                     //     Sell
   Opn_B=false,                     //     Buy
   Opn_S=false;                     //     Sell
//--------------------------------------------------------------- 3 --

  int IBARS = iBars(symbol, timeframe);
  if(ArraySize(ExtMapBuffer1) < IBARS)
    {
      ArraySetAsSeries(ExtMapBuffer1, false);
      ArrayResize(ExtMapBuffer1, IBARS);        
      ArraySetAsSeries(ExtMapBuffer1, true);       
    } 
   static int IndCounted;
   int limit;
int counted_bars = IndCounted;
   IndCounted = IBARS - 1;
   limit = IBARS - counted_bars - 1;

for(int i1=limit; i1>=0; i1--)
{
if(Close[i1+1]<Close[i1+5])num = num + 1; 
else num = 0;	
	
		if (num == 9) {textVar = num;
	        ObjectCreate(""+i1, OBJ_TEXT, 0, Time[i1+1],Low[i1+1]-5*Point );
                ObjectSetText(""+i1, ""+DoubleToStr(num,0), 16, "Arial", Red);}			

if(Close[i1+1]>Close[i1+5]) num1 = num1 + 1; 
else num1 = 0;
	
		if (num1 == 9) {textVar = num1;
		ObjectCreate(""+i1, OBJ_TEXT, 0, Time[i1+1],High[i1+1]+10*Point );
                ObjectSetText(""+i1, ""+DoubleToStr(num1,0), 16, "Arial", RoyalBlue); }
}


   // .
   
   if(Work==false)                              //  
     {
      Alert(" .   .");
      return;                                   //   start()
     }
//--------------------------------------------------------------- 4 --
   //  
   Secwenta=Symbol();                               //  ..
   Total=0;                                     //  
   for(int i=1; i<=OrdersTotal(); i++)          //   
     {
      if (OrderSelect(i-1,SELECT_BY_POS)==true) //   
        {                                       //  :
         if (OrderSymbol()!=Secwenta)continue;      //   . 
         if (OrderType()>1)                     //  
           {
            Alert("  .   .");
            return;                             //   start()
           }
         Total++;                               //  . 
         if (Total>1)                           //    
           {
            Alert("  .   .");
            return;                             //   start()
           }
         Ticket=OrderTicket();                  //  . .
         Tip   =OrderType();                    //   .
         Price =OrderOpenPrice();               //  . .
         SL    =OrderStopLoss();                // SL  .
         TP    =OrderTakeProfit();              // TP  .
         Lot   =OrderLots();                    //  
        }
     }
//--------------------------------------------------------------- 5 --
   //  
 
   if (num == 9)                                
     {                                          
      Opn_B=true;                               //  . Buy
      Cls_S=true;                               //  . Sell
     }
   if (num1 == 9)          
     {                                          
      Opn_S=true;                               //  . Sell
      Cls_B=true;                               //  . Buy
     }
//--------------------------------------------------------------- 6 --
   //  
   while(true)                                  //   .
     {
      if (Tip==0 && Cls_B==true)                //   Buy..
        {                                       //   
         Alert("  Buy ",Ticket,".  ..");
         RefreshRates();                        //  
         Ans=OrderClose(Ticket,Lot,Bid,2);      //  Buy
         if (Ans==true)                         //  :)
           {
            Alert ("  Buy ",Ticket);
            break;                              //    
           }
         if (Fun_Error(GetLastError())==1)      //  
            continue;                           //  
         return;                                //   start()
        }
 
      if (Tip==1 && Cls_S==true)                //   Sell..
        {                                       //    
         Alert("  Sell ",Ticket,".  ..");
         RefreshRates();                        //  
         Ans=OrderClose(Ticket,Lot,Ask,2);      //  Sell
         if (Ans==true)                         //  :)
           {
            Alert ("  Sell ",Ticket);
            break;                              //    
           }
         if (Fun_Error(GetLastError())==1)      //  
            continue;                           //  
         return;                                //   start()
        }
      break;                                    //   while
     }
//--------------------------------------------------------------- 7 --
   //  
   RefreshRates();                              //  
   Min_Lot=MarketInfo(Secwenta,MODE_MINLOT);        // . .  
   Free   =AccountFreeMargin();                 //  
   One_Lot=MarketInfo(Secwenta,MODE_MARGINREQUIRED);//  1 
   Step   =MarketInfo(Secwenta,MODE_LOTSTEP);       //   
 
   if (Lots > 0)                                //   , 
      Lts =Lots;                                //     
   else                                         // %  
      Lts=MathFloor(Free*Prots/One_Lot/Step)*Step;//  
 
   if(Lts < Min_Lot) Lts=Min_Lot;               //   
   if (Lts*One_Lot > Free)                      //   .
     {
      Alert("     ", Lts," ");
      return;                                   //   start()
     }
//--------------------------------------------------------------- 8 --
   //  
   while(true)                                  //   .
     {
      if (Total==0 && Opn_B==true)              //  .  +
        {                                       //  . Buy
         RefreshRates();                        //  
         SL=Bid - New_Stop(StopLoss)*Point;     //  SL .
         TP=Bid + New_Stop(TakeProfit)*Point;   //  TP .
         Alert("  Buy.  ..");
         Ticket=OrderSend(Secwenta,OP_BUY,Lts,Ask,2,SL,TP);// Buy
         if (Ticket > 0)                        //  :)
           {
            Alert ("  Buy ",Ticket);
            return;                             //   start()
           }
         if (Fun_Error(GetLastError())==1)      //  
            continue;                           //  
         return;                                //   start()
        }
      if (Total==0 && Opn_S==true)              //  .  +
        {                                       //  . Sell
         RefreshRates();                        //  
         SL=Ask + New_Stop(StopLoss)*Point;     //  SL .
         TP=Ask - New_Stop(TakeProfit)*Point;   //  TP .
         Alert("  Sell.  ..");
         Ticket=OrderSend(Secwenta,OP_SELL,Lts,Bid,2,SL,TP);// Sel
         if (Ticket > 0)                        //  :)
           {
            Alert ("  Sell ",Ticket);
            return;                             //   start()
           }
         if (Fun_Error(GetLastError())==1)      //  
            continue;                           //  
         return;                                //   start()
        }
      break;                                    //   while
     }
//--------------------------------------------------------------- 9 --
   return;                                      //   start()
  }
//-------------------------------------------------------------- 10 --
int Fun_Error(int Error)                        // -  
  {
   switch(Error)
     {                                          //              
      case  4: Alert("  .   ..");
         Sleep(3000);                           //  
         return(1);                             //   
      case 135:Alert(" .   ..");
         RefreshRates();                        //  
         return(1);                             //   
      case 136:Alert(" .   ..");
         while(RefreshRates()==false)           //   
            Sleep(1);                           //   
         return(1);                             //   
      case 137:Alert(" .   ..");
         Sleep(3000);                           //  
         return(1);                             //   
      case 146:Alert("  .  ..");
         Sleep(500);                            //  
         return(1);                             //   
         //  
      case  2: Alert(" .");
         return(0);                             //   
      case  5: Alert("  .");
         Work=false;                            //   
         return(0);                             //   
      case 64: Alert(" .");
         Work=false;                            //   
         return(0);                             //   
      case 133:Alert(" .");
         return(0);                             //   
      case 134:Alert("    .");
         return(0);                             //   
      default: Alert("  ",Error); //     
         return(0);                             //   
     }
  }
//-------------------------------------------------------------- 11 --
int New_Stop(int Parametr)                      //  -.
  {
   int Min_Dist=MarketInfo(Secwenta,MODE_STOPLEVEL);// . 
   if (Parametr < Min_Dist)                     //   .
     {
      Parametr=Min_Dist;                        //  .
      Alert("  -.");
     }
   return(Parametr);                            //  
  }
//-------------------------------------------------------------- 12 --